-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

local O = addon .. "_OptionsPanel"
Heddframe.OptionsPanel = CreateFrame("Frame", O)
Heddframe.OptionsPanel.name=addon
local OptionsPanel = Heddframe.OptionsPanel

local title = OptionsPanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
title:SetText(addon.." ("..GetAddOnMetadata(addon, "X-Curse-Packaged-Version")..")")
title:SetPoint("TOPLEFT", cfg.options_shift, -cfg.options_shift)

local ResetButton = CreateFrame("Button", nil, OptionsPanel, "OptionsButtonTemplate")
ResetButton:SetText("Reset")
ResetButton:SetPoint("TOPRIGHT", -cfg.options_shift, -cfg.options_shift)



local size_slider = lib.SliderAdd(OptionsPanel,O.."_isize",cfg.isize_min, cfg.isize_max,cfg.isize,
	function(self, v)
	_G[self:GetName().."Text"]:SetText(v)
	HeddDB.isize=v
	lib.FrameResize(_G[O.."_icondummy"],HeddDB.isize)
	lib.MainRefresh()
	end)
size_slider:SetPoint("TOPLEFT", title,"BOTTOMLEFT", 0, -30)
local size_lable=hedlib.CreateFont(OptionsPanel, cfg.textfont, 12, "OUTLINE")
size_lable:SetPoint("BOTTOMLEFT", size_slider,"TOPLEFT", 0, 0)
size_lable:SetText("Icon size:")

local move=lib.CheckboxAdd(OptionsPanel,"Move",nil,
	function(self)
	lib.Hedd_slash("move")
    end)

move:SetPoint("BOTTOMRIGHT", size_slider ,"TOPRIGHT")

local bar_slider = lib.SliderAdd(OptionsPanel,O.."_bsize",cfg.isize_min, cfg.isize_max,cfg.bsize,
	function(self, v)
	_G[self:GetName().."Text"]:SetText(v)
	HeddDB.bsize=v
	_G[O.."_icondummy"].bar:SetHeight(HeddDB.bsize)
	lib.MainRefresh()
	end)
bar_slider:SetPoint("TOPLEFT", size_slider,"BOTTOMLEFT", 0, -30)
local bar_lable=hedlib.CreateFont(OptionsPanel, cfg.textfont, 12, "OUTLINE")
bar_lable:SetPoint("BOTTOMLEFT", bar_slider,"TOPLEFT", 0, 0)
bar_lable:SetText("Bar size:")

local text_slider = lib.SliderAdd(OptionsPanel,O.."_tsize",cfg.tsize_min, cfg.tsize_max,cfg.tsize,
	function(self, v)
	_G[self:GetName().."Text"]:SetText(v)
	HeddDB.tsize=v
	lib.MainRefresh()
	hedlib.UpdateFS(_G[O.."_icondummy"].text,HeddDB.tsize)
	end)
text_slider:SetPoint("TOPLEFT", bar_slider,"BOTTOMLEFT", 0, -30)
local text_lable=hedlib.CreateFont(OptionsPanel, cfg.textfont, 12, "OUTLINE")
text_lable:SetPoint("BOTTOMLEFT", text_slider,"TOPLEFT", 0, 0)
text_lable:SetText("Text size:")

local icon_dummy = lib.AddIconButton(OptionsPanel,O.."_icondummy",cfg.isize,6603,"OVERLAY")
icon_dummy:SetPoint("TOPRIGHT", ResetButton,"BOTTOMRIGHT", 0, -10)
icon_dummy.text = icon_dummy.text or hedlib.CreateFont(OptionsPanel, cfg.textfont, cfg.tsize, "OUTLINE")
icon_dummy.text:SetPoint("TOP",icon_dummy,"BOTTOM")
icon_dummy.text:SetText("dps")
icon_dummy.bar=icon_dummy.bar or CreateFrame("StatusBar", O.."_bar", OptionsPanel)
icon_dummy.bar:SetWidth(20)
icon_dummy.bar:SetHeight(cfg.bsize)
icon_dummy.bar:SetStatusBarTexture(cfg.statusbar_texture)
icon_dummy.bar:SetStatusBarColor(124/255, 252/255, 0)
icon_dummy.bar:SetPoint("RIGHT",icon_dummy,"LEFT")
icon_dummy.bar:Show()

local cd_slider = lib.SliderAdd(OptionsPanel,O.."_cdsize",cfg.isize_min, cfg.isize_max,cfg.cdsize,
	function(self, v)
	_G[self:GetName().."Text"]:SetText(v)
	HeddDB.cdsize=v
	lib.Hedd_slash("cd size "..(HeddDB.cdsize or cfg.cdsize))
	end)
cd_slider:SetPoint("TOPLEFT", text_slider,"BOTTOMLEFT", 0, -30)
local cd_lable=hedlib.CreateFont(OptionsPanel, cfg.textfont, 12, "OUTLINE")
cd_lable:SetPoint("BOTTOMLEFT", cd_slider,"TOPLEFT", 0, 0)
cd_lable:SetText("CD size:")

local cd_hide_lable=hedlib.CreateFont(OptionsPanel, cfg.textfont, 12, "OUTLINE")
cd_hide_lable:SetPoint("BOTTOMLEFT", OptionsPanel,"BOTTOMLEFT", cfg.options_shift, cfg.options_shift+cfg.isize+5)
cd_hide_lable:SetText("CD hide:")

OptionsPanel.refresh = function()
	icon_dummy.texture:SetTexture((select(3,GetSpellInfo(75))) or (select(3,GetSpellInfo(19881))) or (select(3,GetSpellInfo(6603))))
	lib.SliderSet(size_slider,HeddDB.isize)
	lib.FrameResize(icon_dummy,HeddDB.isize)
	lib.SliderSet(bar_slider,HeddDB.bsize)
	icon_dummy.bar:SetHeight(HeddDB.bsize)
	lib.SliderSet(text_slider,HeddDB.tsize)
	hedlib.UpdateFS(icon_dummy.text,HeddDB.tsize)
	lib.SliderSet(cd_slider,HeddDB.cdsize)
	if cfg.move then
		move:SetChecked(true)
	else
		move:SetChecked(nil)
	end
end

ResetButton:SetScript("OnClick", function()
	HeddDB={}
	HeddDB.CD={}
	HeddDB.isize=cfg.isize
	HeddDB.bsize=cfg.bsize
	HeddDB.tsize=cfg.tsize
	lib.MainRefresh()
	HeddDB.cdsize=cfg.cdsize
	lib.CDShowAll()
	lib.CDRefresh()
	OptionsPanel.refresh()
	lib.CDOptionsUncheckAll()
end)

Heddframe.OptionsPanel=OptionsPanel

InterfaceOptions_AddCategory(OptionsPanel)